//Example program for development-on-the-fly with Flash-Pro ( FPA )
//at each MCU source file change.
//======================================================================
//======================================================================
//======================================================================
#ifndef linux
	ERROR
#endif
#if 	defined FLASHPROARM
	#include "FlashProARM-Dll.h"
#endif
#include <stdlib.h>		//system()
#include <stdio.h>		//printf()
#include <time.h>		//nanosleep()
#include <string.h>		//strcpy
#include <signal.h>		//SIGINT handler
void exitHandler( int signalIn )
{	printf( "\nProgram terminated.\n" );
	exit( EXIT_SUCCESS );
};
//======================================================================
//======================================================================
//======================================================================
#define VERBOSITY_LEV	0x1 		//0x0 no messages
#define PROG_SIZE 		0x2000000 	//32MiB source code limit
#define COMM_SIZE 		0x100		//system commands buff size

//======================================================================
//global variables:
int  st, sysRet, firstRun, c, n, currentChecksum, previousFileChecksum;
long f_size; FILE *file;
struct timespec ts;
char* cPtr;
char stderrLogFileName[ 0x20 ] = "build/CCstderr.txt";
char stdoutLogFileName[ 0x20 ] = "build/CCstdout.txt";
char tmp[ COMM_SIZE ];
char objFileName[ COMM_SIZE ];
char elfFileName[ COMM_SIZE ];
char hexFileName[ COMM_SIZE ];
char cstArr[ PROG_SIZE ];
#define CC	"arm-none-eabi-gcc "
char MCU_CC_COMM[ COMM_SIZE * 2 ] =
		CC
		"-Wall -fmax-errors=2 -O1 -pipe "
		"-mcpu=cortex-m0plus -mthumb "
;
char MCU_HEX[ COMM_SIZE ] =
	"arm-none-eabi-objcopy "
		"-Oihex "
;

//======================================================================
//function pointers:
void initFPA( int argc, char* argv[], int verbose );
int fileCS( char *fileName );
int compileMCU_source( int argc, char* argv[], int verbose );
int runMCU( int verbose );
void sleep( int ms );
int main( int argc, char* argv[] );
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%				MAIN 				%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int main( int argc, char* argv[] )
{	if ( argc != 4 ) { printf( "ERROR!\n usage: <FPAconfig.cfg/MCU_NAME> <MCU_source.c> <MCU_linkerFile.ld>" ); return -1; };
	initFPA( argc, argv, VERBOSITY_LEV );
	firstRun = 0x1; compileMCU_source( argc, argv, VERBOSITY_LEV );

	while( 1 )
	{	if ( previousFileChecksum != fileCS( argv[ argc - 2 ] ) )
		{	sysRet = system( "clear" );
			if ( compileMCU_source( argc, argv, VERBOSITY_LEV ) == 0x0 )
				runMCU( VERBOSITY_LEV ); //if compilation was succesfull, then run code on MCU
			previousFileChecksum = fileCS( argv[ argc - 2 ] );
		};
	};
};//end of main()
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
void sleep( int ms )
{	ts.tv_sec = ms / 1000;
	ts.tv_nsec = ( ms % 1000 ) * 1000000;
	nanosleep( &ts, NULL );
};

#define CHECK_ST if ( st != 0x1 ){ if ( verbose ) { printf( "\t FPA ERROR!\n" ); }; exit(-1); };
int runMCU( int verbose )
{	st =  F_ReadCodeFile( hexFileName ); CHECK_ST; if ( verbose ) printf( "F_ReadCodeFile(\"%s\") : %i\n", hexFileName, st ); 	
	st =  F_AutoProgram( 1 ); CHECK_ST; if ( verbose ) printf( "F_AutoProgram(1) : %i\n", st ); 	
	return 0x0;
};

int compileMCU_source( int argc, char* argv[], int verbose )
{	if ( firstRun == 0x1 )
	{	signal( SIGINT, exitHandler );
		//Filenames
			strncpy( elfFileName, argv[ argc - 2 ], strlen( argv[ argc - 2 ] ) - 2 ); //*.c
			strcpy( &elfFileName[ strlen( elfFileName ) ], ".elf" );
			strncpy( hexFileName, elfFileName, strlen( elfFileName ) - 4 ); //*.elf
			strcpy( &hexFileName[ strlen( hexFileName ) ], ".hex" );
			strncpy( objFileName, elfFileName, strlen( elfFileName ) - 4 ); //*.elf
			strcpy( &objFileName[ strlen( objFileName ) ], ".o" );
			
		//MCU source file compilation
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " -c " );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], argv[ argc - 2 ] );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " -o " );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], objFileName ); 
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " 2> " ); 
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], stderrLogFileName );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " 1> " ); 
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], stdoutLogFileName );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " && " );
		
		//MCU source file linkage
		strcpy( tmp, CC );
		strcpy( &tmp[ strlen( tmp ) ], " " );
		strcpy( &tmp[ strlen( tmp ) ], objFileName );
		strcpy( &tmp[ strlen( tmp ) ], " -nostartfiles -nodefaultlibs -nostdlib -specs=nosys.specs " );
		strcpy( &tmp[ strlen( tmp ) ], " -T" );
		strcpy( &tmp[ strlen( tmp ) ], argv[ argc - 1 ] );
		strcpy( &tmp[ strlen( tmp ) ], " -o " );
		strcpy( &tmp[ strlen( tmp ) ], elfFileName ); 
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], tmp );
		
		//generating Intel HEX file from ELF file
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " && rm -f " );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], hexFileName );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " && " );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], MCU_HEX );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], elfFileName ); 
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], " " );
		strcpy( &MCU_CC_COMM[ strlen( MCU_CC_COMM ) ], hexFileName );
			if ( verbose ) printf( "%s\n", MCU_CC_COMM );
		firstRun = 0x2;
	};
	sysRet = system( MCU_CC_COMM );//MCU source file compilation && linkage && ELF->HEX
		if ( sysRet != 0x0 ) 
		{	strcpy( tmp, "echo \"=============================\"&&cat " );
			strcpy( &tmp[ strlen( tmp ) ], stderrLogFileName );
			strcpy( &tmp[ strlen( tmp ) ], "&&echo \"=============================\"" );
			sysRet = system( tmp );
			sleep( 100 );
			return -1;
		};
	return 0;
};

int fileCS( char *fileName ) 
{   c = n = currentChecksum = 0x0; f_size = 0x0;
	file = fopen( fileName, "r" );
		if ( file == NULL ) { printf( "====\n\tCould not open file (\"%s\")!\n====\n", fileName ); return 0x0; };
		fseek( file, 0, SEEK_END );
		f_size = ftell( file );
		if ( f_size > ( long )PROG_SIZE ){ printf( "====\n\tFile(\"%s\") too big!\n====\n", fileName ); return 0x0; };
		fseek( file, 0, SEEK_SET );
		while ( ( c = fgetc( file ) ) != EOF )
		{	cstArr[ n++ ] = ( char )c;
			currentChecksum += c;
		};
		cstArr[ n ] = '\0';
    fclose( file );
	return currentChecksum;
};

void initFPA( int argc, char* argv[], int verbose )
{	strcpy( tmp, "*# *" );
	st =  F_OpenInstancesAndFPAs( tmp ); CHECK_ST; if ( verbose ) printf( "F_OpenInstancesAndFPAs(\"%s\") : %i\n", tmp, st ); 	
	st =  F_Initialization(); CHECK_ST; if ( verbose ) printf( "F_Initialization() : %i\n", st ); 
	strcpy( tmp, argv[ argc - 3 ] ); 
	
	//MCU configuration via config file
	if ( strcmp( &tmp[ strlen( tmp ) - 4 ], ".cfg" ) == 0x0 )
	{	st =  F_ConfigFileLoad( tmp ); CHECK_ST; if ( verbose ) printf( "F_ConfigFileLoad(\"%s\") : %i\n", tmp, st ); 
		st =  F_Set_Config_Value_By_Name( ( char* )"ResetTimeIndex", 0x1 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"ResetTimeIndex\", 0x1 ) : %i\n", st ); 
		st =  F_Set_Config_Value_By_Name( ( char* )"ApplicationStartEnable", 0x1 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"ApplicationStartEnable\", 0x1 ) : %i\n", st ); 
		return;
	};
	
	//generic MCU configuration via MCU_NAME
	st = (F_Set_MCU_Name( tmp ) != -1); CHECK_ST; if ( verbose ) printf( "F_Set_MCU_Name(\"%s\") : %i\n", tmp, st ); 
	c = 0x0;
	if ( verbose )
	{	printf( "\nSetting FPA configuration to generic defaults:\n" );
		while ( cPtr = F_Get_Config_Name_List( c++ ),
				st = F_Get_Config_Value_By_Name( cPtr, CONFSEL_DEFAULT ),
				F_Set_Config_Value_By_Name( cPtr, st ),
				printf( "%s:0x%X\n",
						cPtr,
						st ) != 0x5
			  );
	};
	if ( verbose == 0x0 )
		while ( cPtr = F_Get_Config_Name_List( c++ ),
				F_Set_Config_Value_By_Name( 
					cPtr, 
					F_Get_Config_Value_By_Name(
							cPtr, 
							CONFSEL_DEFAULT   )
										  )
			  );
	st =  F_Set_Config_Value_By_Name( ( char* )"Interface", COMM_SWD_FAST ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"Interface\", 0x%X ) : %i\n", COMM_SWD_FAST, st );  
	st =  F_Set_Config_Value_By_Name( ( char* )"VccFromFPAin_mV", 3300 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"VccFromFPAin_mV\", 3300 ) : %i\n", st );  
	st =  F_Set_Config_Value_By_Name( ( char* )"PowerFromFpaEn", 0x1 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"PowerFromFpaEn\", 0x1 ) : %i\n", st );  
	st =  F_Set_Config_Value_By_Name( ( char* )"ResetTimeIndex", 0x1 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"ResetTimeIndex\", 0x1 ) : %i\n", st ); 
	st =  F_Set_Config_Value_By_Name( ( char* )"ApplicationStartEnable", 0x1 ); CHECK_ST; if ( verbose ) printf( "F_Set_Config_Value_By_Name( \"ApplicationStartEnable\", 0x1 ) : %i\n", st ); 
};
